<?php

namespace ByDedi\AdminBundle\Form\Extension;

use Sonata\CoreBundle\Form\Type\DatePickerType;
use Symfony\Component\Form\AbstractTypeExtension;
use Symfony\Component\Form\Extension\Core\Type\ButtonType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

/**
 * Created by PhpStorm.
 * User: FrédéricGuichard
 * Date: 16/11/2016
 * Time: 11:54
 */
class DatePickerTypeExtension extends AbstractTypeExtension
{
    const DEFAULT_FORMAT = 'd-m-Y';
    const SQL_FORMAT = 'Y-m-d';

    public function __construct()
    {
    }

    public function getExtendedType()
    {
        return DatePickerType::class;
    }

    /**
     * Add the image_path option
     *
     * @param OptionsResolver $resolver
     */
    public function setDefaultOptions(\Symfony\Component\OptionsResolver\Options $resolver)
    {
        $resolver->setDefaults(
            [
                'format' => 'dd-MM-yyyy',
                'dp_format' => 'DD-MM-YYYY',
                'dp_language' => 'fr',
            ]
        );
    }

    /**
     * {@inheritdoc}
     */
    public function buildView(FormView $view, FormInterface $form, array $options)
    {
    }

    /**
     * Add the image_path option
     *
     * @param OptionsResolver $resolver
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $this->setDefaultOptions($resolver);
    }
}
