<?php
/**
 * Created by PhpStorm.
 * User: YannickBreillet
 * Date: 03/02/2017
 * Time: 11:57
 */

namespace ByDedi\AdminBundle\Form\Type;

use Symfony\Component\DependencyInjection\Container;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\PropertyAccess\PropertyAccessorInterface;

class AdvancedSearchType extends AbstractType
{
    private $container;
    private $propertyAccessor;

    /**
     * AdvancedSearchType constructor.
     * @param Container $container
     * @param PropertyAccessorInterface $propertyAccessor*
     */
    public function __construct(Container $container, PropertyAccessorInterface $propertyAccessor)
    {
        $this->container = $container;
        $this->propertyAccessor = $propertyAccessor;
    }


    /**
     * @param OptionsResolver $resolver
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'admin_service' => '',
            'hide_columns' => [],
            'query_string' => null,
            'search_entities' => []
        ));

        parent::configureOptions($resolver);
    }

    /**
     * @param FormView $view
     * @param FormInterface $form
     * @param array $options
     */
    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $admin = $this->container->get($options['admin_service']);
        $view->vars['admin'] = $admin;
        $view->vars['search_entities'] = $options['search_entities'];

        $listUrl = $admin->generateUrl(
            'advancedsearch',
            array_merge(
                $view->vars['sonata_admin']['field_description']->getOption('link_parameters', []),
                [
//                    'origin_id' => $view->vars['sonata_admin']['admin']->getSubject()->getId(),
//                    'pcode' => $view->vars['sonata_admin']['admin']->getCode(),
//                    '_list_mode' => 'list',
                    'select_id' => $view->vars['id'],
                ]
            )
        );
        $view->vars['url'] = $listUrl;
        $view->vars['pcode'] = $view->vars['sonata_admin']['admin']->getCode();
    }

    /**
     * @return string
     */
    public function getBlockPrefix()
    {
        return 'advanced_search_type';
    }

    /**
     * @return string
     */
    public function getParent()
    {
        return 'sonata_type_model';
    }
}
